
#include "tcb.h"
#include "system.h"
#include "schedule.h"

extern tcb *current;
extern tcb task_struct[MAX_TASK_COUNT];

extern unsigned int task_count;
extern unsigned int task_current_pid;

/*
 * 라운드 로빈으로 pid 0번 idle 태스크로부터
 * load된 마지막 태스크까지 순차적으로 스케줄링 한다.
 * 차후에 태스크마다 우선순위를 줄것이다.
 */
void schedule()
{
    task_current_pid++;

    if (task_current_pid >= task_count || task_current_pid >= MAX_TASK_COUNT)
	task_current_pid = 0;

    current = &task_struct[task_current_pid];
}
